import { Image } from 'itk-wasm';
import DownsampleNodeOptions from './downsample-node-options.js';
import DownsampleNodeResult from './downsample-node-result.js';
/**
 * Apply a smoothing anti-alias filter and subsample the input image.
 *
 * @param {Image} input - Input image
 * @param {DownsampleNodeOptions} options - options object
 *
 * @returns {Promise<DownsampleNodeResult>} - result object
 */
declare function downsampleNode(input: Image, options?: DownsampleNodeOptions): Promise<DownsampleNodeResult>;
export default downsampleNode;
