import { Image } from 'itk-wasm';
import DownsampleOptions from './downsample-options.js';
import DownsampleResult from './downsample-result.js';
/**
 * Apply a smoothing anti-alias filter and subsample the input image.
 *
 * @param {Image} input - Input image
 * @param {DownsampleOptions} options - options object
 *
 * @returns {Promise<DownsampleResult>} - result object
 */
declare function downsample(input: Image, options?: DownsampleOptions): Promise<DownsampleResult>;
export default downsample;
